=== docs/requirements.txt ===
six
testresources
recommonmark
sphinx-press-theme
sphinx-tabs
breathe
