=== debian/changelog ===
opencolorio (2.1.3+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Revert Ubuntu-isms from 2.1.3+dfsg-1.2. (Closes: #1111494)

 -- Bastian Germann <bage@debian.org>  Mon, 18 Aug 2025 19:39:37 +0200

opencolorio (2.1.3+dfsg-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix pystring includes. Closes: #1084313.

 -- Matthias Klose <doko@debian.org>  Wed, 08 Jan 2025 16:12:16 +0100
