=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/opencolorio-$1\.tar\.gz/, \
dversionmangle=s/\+dfsg.*//, \
repack, \
repacksuffix=+dfsg" \
https://github.com/AcademySoftwareFoundation/OpenColorIO/tags .*/v(\d.*)\.(?:tgz|tar\.(?:gz|bz2|xz))
